## tarantool-lts 1.5.4.28.gfcf2fef

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(tarantool C CXX)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set(CMAKE_INCLUDE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_INCLUDE_PATH})


include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckSymbolExists)
include(CheckCSourceRuns)
include(CheckCXXSourceRuns)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(TestBigEndian)
include(CheckFunctionExists)
include(FindOptionalPackage)

find_program(ECHO echo)
find_program(XSLTPROC xsltproc)
find_program(XMLLINT xmllint)
find_program(JING jing)
find_program(LYNX lynx)
find_program(CAT cat)
find_program(GIT git)
find_program(RAGEL ragel)
find_program(CONFETTI confetti)
find_program(LD ld)
find_program(POD2MAN pod2man)


#
# This instructs the rest of the build system what product
# and what modules to produce.
#
set (TARANTOOL_PRODUCT "box")
set (TARANTOOL_MODULES "box")
set (TARANTOOL_CLIENTS "tarancheck" "tarantar")
# Define PACKAGE macro in tarantool/config.h
set (PACKAGE "Tarantool")

#
# Set default build type to Debug. This is to ease a developer's
# life. Release binaries are built by BuildBot automatically anyway.
#
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

# Define GNU standard installation directories
include(GNUInstallDirs)

include(cmake/utils.cmake)

# the order is significant: we need to know os and compiler to configure libs
include(cmake/arch.cmake)
include(cmake/os.cmake)
include(cmake/compiler.cmake)
include(cmake/simd.cmake)
include(cmake/profile.cmake)

option(ENABLE_VALGRIND "Enable integration with valgrind, a memory analyzing tool" OFF)

check_symbol_exists(MAP_ANON sys/mman.h HAVE_MAP_ANON)
check_symbol_exists(MAP_ANONYMOUS sys/mman.h HAVE_MAP_ANONYMOUS)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(unwind.h HAVE_UNWIND_H)
check_include_file(cpuid.h HAVE_CPUID_H)
check_include_file(sys/prctl.h HAVE_PRCTL_H)

check_symbol_exists(O_DSYNC fcntl.h HAVE_O_DSYNC)
check_symbol_exists(fdatasync unistd.h HAVE_FDATASYNC)
check_function_exists(memmem HAVE_MEMMEM)
check_function_exists(memrchr HAVE_MEMRCHR)

check_function_exists(funopen HAVE_FUNOPEN)

#
# Some versions of GNU libc define non-portable __libc_stack_end
# which we use to determine the end (or beginning, actually) of
# stack. Find whether or not it's present.
check_library_exists("" __libc_stack_end "" HAVE_LIBC_STACK_END)

#
# Enable 'make tags' target.
#
add_custom_target(tags COMMAND ctags -R -f tags
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

#
# Define PACKAGE_VERSION -- a string constant with tarantool version.
#
set (CPACK_PACKAGE_VERSION_MAJOR "1")
set (CPACK_PACKAGE_VERSION_MINOR "5")
set (CPACK_PACKAGE_VERSION_PATCH "4")

set (PACKAGE_VERSION "")

# Get git version only if source directory has .git repository, this
# avoids git to search .git repository in parent
# directories.
#
if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
	execute_process (COMMAND ${GIT} describe HEAD
		OUTPUT_VARIABLE PACKAGE_VERSION
		OUTPUT_STRIP_TRAILING_WHITESPACE
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    if (PACKAGE_VERSION STREQUAL "")
        message (FATAL_ERROR "Failed to retrive git version.")
    endif()
endif()

set (VERSION_FILE "${CMAKE_SOURCE_DIR}/VERSION")

# Update version file or use it when there is no git
# repository within sources (source tarballs).
#
if (PACKAGE_VERSION STREQUAL "")
    if (NOT EXISTS "${VERSION_FILE}")
        message (FATAL_ERROR "Version file ${VERSION_FILE} does not exists.")
    endif()
    message (WARNING "Using version from version file ${VERSION_FILE}")
	execute_process (COMMAND ${CAT} ${VERSION_FILE}
		OUTPUT_VARIABLE PACKAGE_VERSION
		OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (PACKAGE_VERSION STREQUAL "")
        message (FATAL_ERROR "Unable to retrive version from git or ${VERSION_FILE} file.")
    endif()
else()
	file(WRITE ${VERSION_FILE} "${PACKAGE_VERSION}\n")
endif()

#
# Specify where to look for include files.
#
include_directories("${PROJECT_SOURCE_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/include")
include_directories("${PROJECT_BINARY_DIR}/include")
include_directories("${PROJECT_SOURCE_DIR}/third_party")

#
# Specify Tarantool modules prefixes
#

set(MODULE_SUFFIX "tarantool")
set(MODULE_LIBDIR "${CMAKE_INSTALL_LIBDIR}/${MODULE_SUFFIX}")
set(MODULE_LUADIR "${CMAKE_INSTALL_DATADIR}/${MODULE_SUFFIX}")
set(MODULE_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/${MODULE_SUFFIX}")

foreach(dir
        LIBDIR
        LUADIR
        INCLUDEDIR
        )
    if(NOT IS_ABSOLUTE ${MODULE_${dir}})
        set(MODULE_FULL_${dir} "${CMAKE_INSTALL_PREFIX}/${MODULE_${dir}}")
    else()
        set(MODULE_FULL_${dir} "${MODULE_${dir}}")
    endif()
endforeach()

message(STATUS "Module sources:   ${MODULE_FULL_LUADIR}")
message(STATUS "Module libraries: ${MODULE_FULL_LIBDIR}")
message(STATUS "Module includes:  ${MODULE_FULL_INCLUDEDIR}")

list(APPEND MODULE_LUAPATH "${MODULE_FULL_LUADIR}/?.lua")
list(APPEND MODULE_LUAPATH "${MODULE_FULL_LUADIR}/?/init.lua")
list(APPEND MODULE_LIBPATH "${MODULE_FULL_LIBDIR}/?${CMAKE_SHARED_MODULE_SUFFIX}")
message(STATUS "Module package.path: ${MODULE_LUAPATH}")
message(STATUS "Module package.cpath: ${MODULE_LIBPATH}")

#
# Now handle all configuration options.
#
option(ENABLE_DOC "Enable building of documentation" OFF)

option(ENABLE_CLIENT "Enable building of console client" OFF)
if (ENABLE_CLIENT)
    set (TARANTOOL_CLIENTS ${TARANTOOL_CLIENTS} "tarantool")
endif()

option(ENABLE_TRACE "Enable debug trace of tarantool_box execution to
a file specified in TARANTOOL_TRACE environment variable" ON)

option(ENABLE_BACKTRACE "Enable output of fiber backtrace information in 'show
fiber' administrative command. Only works on x86 architectures, if compiled
with gcc. If GNU binutils and binutils-dev libraries are installed, backtrace
is output with resolved function (symbol) names. Otherwise only frame
addresses are printed." ${CMAKE_COMPILER_IS_GNUCC})

set (HAVE_BFD False)
if (ENABLE_BACKTRACE)
    if (NOT ${CMAKE_COMPILER_IS_GNUCC} OR
        NOT (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86|amd64"))
        # We only know this option to work with gcc
        # on x86 architecture.
        message (FATAL_ERROR "ENABLE_BACKTRACE option is set but the system is not x86 based (${CMAKE_SYSTEM_PROCESSOR}) or the compiler is not GNU GCC (${CMAKE_C_COMPILER}).")
    endif()
    # Use GNU bfd if present.
    check_library_exists (bfd bfd_init ""  HAVE_BFD_LIB)
    check_library_exists (iberty cplus_demangle "" HAVE_IBERTY_LIB)
    set(CMAKE_REQUIRED_DEFINITIONS -DPACKAGE=${PACKAGE} -DPACKAGE_VERSION=${PACKAGE_VERSION})
    check_include_file(bfd.h HAVE_BFD_H)
    set(CMAKE_REQUIRED_DEFINITIONS)
    if (HAVE_BFD_LIB AND HAVE_BFD_H AND HAVE_IBERTY_LIB)
        set (HAVE_BFD True)
    endif()
endif()

option(ENABLE_STATIC "Perform static linking whenever possible." OFF)
if (ENABLE_STATIC)
    add_compile_flags("C;CXX" "-static")
endif()

##
## Third-Party libraries
##

#
# Since we *optionally* build bundled libs, a direct build
# dependency between tarantool_box and libluajit/libobjc won't
# work: add an empty custom target for this dependency instead.
# If a bundled objc or luajit is built, it is added to the
# dependency list of build_bundled_libs target.
#

add_custom_target(build_bundled_libs)

#
# LibLUAJIT
#
include(luajit)


#
# LibEV
#

#
# Currently our code uses libev with #define EV_MULTIPLICITY 0.
# This option means that libev has a global variable with
# struct ev_loop data.
# Such design is not compatible with the dynamic version of libev
# provided by distros.
set(ENABLE_BUNDLED_LIBEV ON)
include(BuildLibEV)
libev_build()
add_dependencies(build_bundled_libs ev)

#
# LibEIO
#
option(ENABLE_BUNDLED_LIBEIO "Enable building of the bundled libeio" ON)

if (ENABLE_BUNDLED_LIBEIO)
    include(BuildLibEIO)
    libeio_build()
    add_dependencies(build_bundled_libs eio)
else()
    set(LIBEIO_FIND_REQUIRED ON)
    find_package(LibEIO)
endif()


#
# LibCORO
#

#
# Tarantool uses 'coro' (coroutines) library to implement
# cooperative multi-tasking. Since coro.h is included
# universally, define the underlying implementation switch
# in the top level CMakeLists.txt, to ensure a consistent
# header file layout across the entire project.
#
set(ENABLE_BUNDLED_LIBCORO ON)
include(BuildLibCORO)
libcoro_build()
add_dependencies(build_bundled_libs coro)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86" OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "amd64")
    add_definitions("-DCORO_ASM")
else()
    add_definitions("-DCORO_SJLJ")
endif()


#
# LibGOPT
#

include(BuildLibGOPT)
libgopt_build()
add_dependencies(build_bundled_libs gopt)

#
# LibCJSON
#

include(BuildLibCJSON)
libcjson_build()
add_dependencies(build_bundled_libs cjson)

#
# Third-Party
#

include(BuildMisc)
libmisc_build()
add_dependencies(build_bundled_libs misc)

include(BuildSophia)
sophia_build()

option(ENABLE_RPM "Enable install of a RPM specific files" OFF)

# cpack config. called package.cmake to avoid
# conflicts with the global CPack.cmake (On MacOS X
# file names are case-insensitive)
#
include (cmake/package.cmake)
#
# RPM build environment
# CPACK is only used for .tar.gz package generation.
# To build an RPM we need a source package,
# so rpm.cmake depends on package.cmake.
#
include (cmake/rpm.cmake)

add_subdirectory(cfg)
add_subdirectory(connector)
add_subdirectory(src)
add_subdirectory(extra)
add_subdirectory(client)
add_subdirectory(test)
add_subdirectory(doc)

install (FILES README.md LICENSE doc/box-protocol.txt
         DESTINATION share/doc/tarantool)

#
# tarantool info summary (used in server version output)
#
set(TARANTOOL_OPTIONS "-DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_STATIC=${ENABLE_STATIC}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_TRACE=${ENABLE_TRACE} -DENABLE_BACKTRACE=${ENABLE_BACKTRACE}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_CLIENT=${ENABLE_CLIENT}")
set(TARANTOOL_BUILD "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}-${CMAKE_BUILD_TYPE}")
set(TARANTOOL_C_COMPILER ${CMAKE_C_COMPILER})
set(TARANTOOL_CXX_COMPILER ${CMAKE_CXX_COMPILER})

#
# Output compile-time defines into config.h. Do it at the end
# of the script to make sure all variables are set.
#
configure_file(
    "${PROJECT_SOURCE_DIR}/include/tarantool/config.h.cmake"
    "${PROJECT_BINARY_DIR}/include/tarantool/config.h"
    )
install(FILES ${PROJECT_BINARY_DIR}/include/tarantool/config.h
    DESTINATION ${MODULE_INCLUDEDIR})
message (STATUS "")
message (STATUS "Tarantool configuration is complete:")
message (STATUS "")
message (STATUS "VERSION: ${PACKAGE_VERSION}")
message (STATUS "BUILD: ${TARANTOOL_BUILD}")
message (STATUS "C_COMPILER: ${TARANTOOL_C_COMPILER}")
message (STATUS "CXX_COMPILER: ${TARANTOOL_CXX_COMPILER}")
message (STATUS "C_FLAGS:${TARANTOOL_C_FLAGS}")
message (STATUS "CXX_FLAGS:${TARANTOOL_CXX_FLAGS}")
message (STATUS "PREFIX: ${CMAKE_INSTALL_PREFIX}")
message (STATUS "MODULE_DIR: ${MODULE_DIR}")
message (STATUS "ENABLE_STATIC: ${ENABLE_STATIC}")
message (STATUS "ENABLE_SSE2: ${ENABLE_SSE2}")
message (STATUS "ENABLE_AVX: ${ENABLE_AVX}")
message (STATUS "ENABLE_GCOV: ${ENABLE_GCOV}")
message (STATUS "ENABLE_GPROF: ${ENABLE_GPROF}")
message (STATUS "ENABLE_VALGRIND: ${ENABLE_VALGRIND}")
message (STATUS "ENABLE_TRACE: ${ENABLE_TRACE}")
message (STATUS "ENABLE_BACKTRACE: ${ENABLE_BACKTRACE} (symbol resolve: ${HAVE_BFD})")
message (STATUS "ENABLE_CLIENT: ${ENABLE_CLIENT}")
message (STATUS "ENABLE_BUNDLED_LUAJIT: ${ENABLE_BUNDLED_LUAJIT}")
message (STATUS "ENABLE_BUNDLED_LIBEV: ${ENABLE_BUNDLED_LIBEV}")
message (STATUS "ENABLE_BUNDLED_LIBEIO: ${ENABLE_BUNDLED_LIBEIO}")
message (STATUS "ENABLE_BUNDLED_LIBCORO: ${ENABLE_BUNDLED_LIBCORO}")

=== src/CMakeLists.txt ===
#
# Set compile flags for entire src/ directory
#
enable_tnt_compile_flags()

if (NOT TARGET_OS_DARWIN)
    add_subdirectory(module)
endif()

include_directories(${LIBEV_INCLUDE_DIR})
include_directories(${LIBEIO_INCLUDE_DIR})
include_directories(${LIBCORO_INCLUDE_DIR})
include_directories(${LIBGOPT_INCLUDE_DIR})

# Require pthread globally if compiling with GCC
if (CMAKE_COMPILER_IS_GNUCC)
    add_compile_flags("C;CXX" "-pthread")
endif()

#
# Build admin.cc from admin.rl, but only if admin.rl was changed.
# The same applies to memcached.cc/memcached.rl.
# We track admin.cc and memcached.cc in revision control, and thus do not
# require engineers who do not modify .rl files to have Ragel
# installed.
#
add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/src/admin.cc
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${RAGEL} -G2 src/admin.rl -o src/admin.cc
    DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.rl)

add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/src/memcached-grammar.cc
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${RAGEL} -G2 src/memcached-grammar.rl
                     -o src/memcached-grammar.cc
    DEPENDS ${CMAKE_SOURCE_DIR}/src/memcached-grammar.rl)

add_custom_target(generate_admin_cc DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.cc)
add_custom_target(generate_memcached_grammar_cc DEPENDS
    ${CMAKE_SOURCE_DIR}/src/memcached-grammar.cc)

# do not randomly try to re-generate admin.cc or memcached-grammar.cc
# after a fresh checkout/branch switch.
execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/src/admin.cc
    ${CMAKE_SOURCE_DIR}/src/memcached-grammar.cc)

set_source_files_properties(${CMAKE_SOURCE_DIR}/src/memcached-grammar.cc
    PROPERTIES HEADER_FILE_ONLY true)

set_source_files_properties(memcached.cc
    PROPERTIES COMPILE_FLAGS "-Wno-uninitialized")

#
# # Do not clean admin.cc, memcached.cc or other
# generated files in 'make clean' -- they are under
# revision control.
#
set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM true)

# Compile src/lua/*.lua files into src/lua/*.lua.c sources
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/src/lua)
set(lua_sources)
lua_source(lua_sources lua/uuid.lua)
lua_source(lua_sources lua/digest.lua)
lua_source(lua_sources lua/session.lua)
lua_source(lua_sources lua/bsdsocket.lua)
lua_source(lua_sources lua/errno.lua)

add_custom_target(generate_lua_sources
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/box
    DEPENDS ${lua_sources})
set_property(DIRECTORY PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${lua_sources})

#
# Used by modules.
#
set (recompiled_sources
     ${CMAKE_SOURCE_DIR}/src/tarantool.cc
     ${CMAKE_SOURCE_DIR}/src/opts.c
     ${CMAKE_SOURCE_DIR}/src/lua/init.cc
     ${CMAKE_SOURCE_DIR}/src/say.cc
     ${CMAKE_SOURCE_DIR}/src/assoc.cc
     ${CMAKE_SOURCE_DIR}/src/replication.cc
     ${CMAKE_SOURCE_DIR}/src/memcached.cc
     ${CMAKE_SOURCE_DIR}/src/fiber.cc)

set (common_sources
     tbuf.c
     palloc.cc
     util.cc
     find_path.c
     sio.cc
     evio.cc
     coio.cc
     coeio.cc
     iobuf.cc
     coio_buf.cc
     salloc.cc
     pickle.cc
     coro.cc
     stat.cc
     log_io.cc
     recovery.cc
     admin.cc
     cpu_feature.c
     replica.cc
     iproto.cc
     iproto_port.cc
     session.cc
     object.cc
     exception.cc
     errcode.c
     errinj.cc
     fio.c
     ffisyms.cc
     crc32.c
     rope.c
     ipc.cc
     lua/info.cc
     lua/stat.cc
     lua/slab.cc
     lua/lua_ipc.cc
     lua/lua_socket.cc
     lua/session.cc
     lua/cjson.cc
     lua/errno.c
     lua/bsdsocket.cc
     fiob.c
     ${lua_sources}
)

if (CC_HAS_WNO_UNUSED_CONST_VARIABLE)
    set_source_files_properties(admin.cc PROPERTIES
        COMPILE_FLAGS "-Wno-unused-const-variable") # clang 3.5+
endif()

if (ENABLE_TRACE)
    set (common_sources ${common_sources} trace.c)
endif()

set_source_files_properties(sio.cc evio.cc replica.cc PROPERTIES COMPILE_FLAGS "-Wno-deprecated")
set_source_files_compile_flags(${common_sources})
add_library(core STATIC ${common_sources})
add_dependencies(core generate_headers)

set (common_libraries cfg core)

list(APPEND common_libraries
    ${LIBEV_LIBRARIES}
    ${LIBEIO_LIBRARIES}
    ${LIBCORO_LIBRARIES}
    ${LIBGOPT_LIBRARIES}
    ${LIBCJSON_LIBRARIES}
    ${LUAJIT_LIB}
    misc
)

set (THREAD_LIB pthread)
if (ENABLE_STATIC)
    set (THREAD_LIB -Wl,--whole-archive pthread -Wl,--no-whole-archive)
endif()

set (common_libraries ${common_libraries} ${THREAD_LIB})

if (TARGET_OS_LINUX OR TARGET_OS_DEBIAN_FREEBSD)
    set (common_libraries ${common_libraries} dl)
endif()

if (TARGET_OS_FREEBSD AND NOT TARGET_OS_DEBIAN_FREEBSD)
    find_library (INTL intl)
    if (NOT INTL)
        message(FATAL_ERROR "intl library not found")
    else()
        set (common_libraries ${common_libraries} ${INTL})
    endif()
endif()

if (ENABLE_BACKTRACE AND HAVE_BFD)
    find_package (ZLIB)
    set (common_libraries ${common_libraries} bfd ${ZLIB_LIBRARIES})
    if (NOT TARGET_OS_DARWIN)
        set (common_libraries ${common_libraries} iberty)
    endif()
    if (TARGET_OS_FREEBSD AND NOT TARGET_OS_DEBIAN_FREEBSD)
        set (common_libraries ${common_libraries} iconv)
    endif()
endif()

set (common_libraries ${common_libraries} PARENT_SCOPE)

add_subdirectory(lib)
# Save CMAKE_XXX_FLAGS from this directory for config.h (used in --version)
set(TARANTOOL_C_FLAGS ${CMAKE_C_FLAGS} PARENT_SCOPE)
set(TARANTOOL_CXX_FLAGS ${CMAKE_CXX_FLAGS} PARENT_SCOPE)

function(tarantool_module mod)
    set (module_sources ${ARGN})
    set(cfg_c_flags "-Wno-unused -Wno-unused-parameter")
    if (CMAKE_COMPILER_IS_CLANG)
        set(cfg_c_flags "${cfg_c_flags} -Wno-semicolon-before-method-body")
    endif()
    set_source_files_properties(
        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
        PROPERTIES COMPILE_FLAGS ${cfg_c_flags}
        GENERATED True)
    unset(cfg_c_flags)
    add_executable(tarantool_${mod}
        ${module_sources}
        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c)

    set_source_files_properties(${recompiled_sources}
        PROPERTIES OBJECT_DEPENDS
        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h)

    set_source_files_compile_flags(
        ${recompiled_sources} ${module_sources})

    add_library(lt${mod} STATIC ${recompiled_sources})
    set_target_properties(lt${mod} PROPERTIES COMPILE_FLAGS
        "-DTARANTOOL_CONFIG='<cfg/tarantool_${mod}_cfg.h>'")
    add_dependencies(lt${mod} generate_headers generate_admin_cc generate_memcached_grammar_cc build_bundled_libs)

    target_link_libraries(tarantool_${mod} lt${mod} ${common_libraries} -rdynamic)

    if (ENABLE_STATIC)
        set_target_properties(tarantool_${mod} PROPERTIES
            LINK_SEARCH_END_STATIC ON)
        set (module_link_flags "${module_link_flags} -static")
    endif()

    if (module_link_flags)
        set_target_properties(tarantool_${mod} PROPERTIES
            LINK_FLAGS ${module_link_flags})
    endif()
    install (TARGETS tarantool_${mod} DESTINATION bin)
endfunction()

foreach (module ${TARANTOOL_MODULES})
add_subdirectory(${module})
endforeach()

=== src/box/CMakeLists.txt ===
if (TARGET_OS_DARWIN)
    set(module_link_flags "-pagezero_size 10000 -image_base 100000000")
endif()

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/src/box/lua)

set(lua_sources)
lua_source(lua_sources lua/box.lua)
lua_source(lua_sources lua/box_net.lua)
lua_source(lua_sources lua/misc.lua)

add_custom_target(box_generate_lua_sources
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/box
    DEPENDS ${lua_sources})
set_property(DIRECTORY PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${lua_sources})

tarantool_module("box"
    tuple.cc
    tuple_convert.cc
    tuple_update.cc
    key_def.cc
    index.cc
    hash_index.cc
    tree_index.cc
    avl_tree_index.cc
    bitset_index.cc
    space.cc
    port.cc
    request.cc
    txn.cc
    box.cc
    ${lua_sources}
    box_lua.cc
    box_lua_space.cc)

set_source_files_properties(box_lua.cc PROPERTIES COMPILE_FLAGS "-Wno-deprecated")
target_link_libraries(tarantool_box bitset)

=== test/unit/CMakeLists.txt ===
add_compile_flags("C;CXX" "-Wno-unused")
file(GLOB all_sources *.c *.m *.mm)
set_source_files_compile_flags(${all_sources})

add_executable(fiob.test test.c fiob.c ${CMAKE_SOURCE_DIR}/src/fiob.c)
add_executable(rlist.test rlist.c test.c)
add_executable(queue.test queue.c)
add_executable(mhash.test mhash.c)
add_executable(rope_basic.test rope_basic.c ${CMAKE_SOURCE_DIR}/src/rope.c)
add_executable(rope_avl.test rope_avl.c ${CMAKE_SOURCE_DIR}/src/rope.c)
add_executable(rope_stress.test rope_stress.c ${CMAKE_SOURCE_DIR}/src/rope.c)
add_executable(rope.test rope.c ${CMAKE_SOURCE_DIR}/src/rope.c)
add_executable(bit.test bit.c bit.c)
target_link_libraries(bit.test bit)
add_executable(bitset_basic.test bitset_basic.c)
target_link_libraries(bitset_basic.test bitset)
add_executable(bitset_iterator.test bitset_iterator.c)
target_link_libraries(bitset_iterator.test bitset)
add_executable(bitset_index.test bitset_index.c)
target_link_libraries(bitset_index.test bitset)
add_executable(base64.test base64.c ${CMAKE_SOURCE_DIR}/third_party/base64.c)
add_executable(slab_cache.test slab_cache.c)
target_link_libraries(slab_cache.test small)
add_executable(region.test region.c)
target_link_libraries(region.test small)
add_executable(mempool.test mempool.c)
target_link_libraries(mempool.test small)
add_executable(small_alloc.test small_alloc.c)
target_link_libraries(small_alloc.test small)
add_executable(avl_tree.test avl_tree.c)
target_link_libraries(avl_tree.test m)
target_link_libraries(avl_tree.test misc)

=== debian/changelog ===
tarantool-lts (1.5.4.28.gfcf2fef-1) unstable; urgency=medium

  * Tarantool 1.6 and tarantool 1.5 aren't compatible, so
    rename package tarantool to tarantool-lts (Long Time Support).
  * Update debian/copyright
    + third_party/compat/unwind.h
    + third_party/qsort_arg_mt.c
    + third_party/compat/sys/bsd_time.h
    + third_party/gopt/gopt.*
  * Fix copyright lintian issues (invalid-short-name-in-dep5-copyright).
  * Don't strip tarantool_box: it uses debug symbols runtime.
  * Bump Standard-Version.

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 23 Oct 2014 18:18:34 +0400

tarantool (1.5.3.53.ge2308d8-1) unstable; urgency=medium

  * New Debian snapshot
   + add sophia storage
   + some fixes in box.net.box
   + uses O_DIRECT options to create snapshots
   + update documentation/manpagses
   + memleak in tarantool client

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 19 Feb 2014 18:37:26 +0400

tarantool (1.5.2.20.g5f5d924-1) unstable; urgency=low

  * Rebuild for Debian/unstable (tarantar binary).

 -- Dmitry E. Oboukhov <unera@debian.org>  Sat, 21 Dec 2013 13:18:28 +0400

tarantool (1.5.2.16.g18b8e4e-1) unstable; urgency=low

  * New Debian snapshot.
   - Drop legacy packages (libtarantool*).
   - Drop tarantool-dbg.
   - Don't strip tarantool_box (it uses debug symbols runtime).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 20 Dec 2013 15:44:11 +0400

tarantool (1.5.1.302.gd906190-1) unstable; urgency=low

  * New Debian snapshot.
   - box.session.storage,
   - bugfixes

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 09 Dec 2013 16:23:49 +0400

tarantool (1.5.1.218.g1a69fd6-1) unstable; urgency=low

  * New Debian snapshot
   - patch for OpenVZ (disable MAP_SHARED mmap flag with OpenVZ).
   - fix socket:readline(..., timeout) bug.
   - suggests -dbg version of package.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 19 Nov 2013 16:17:23 +0400

tarantool (1.5.1.150.g029f82f-1) unstable; urgency=low

  * New Debian snapshot (fix memory corruption).

 -- Dmitry E. Oboukhov <unera@debian.org>  Fri, 25 Oct 2013 15:26:36 +0400

tarantool (1.5.1.148.g6dddbc7-1) unstable; urgency=low

  * New Debian snapshot.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 23 Oct 2013 13:46:46 +0400

tarantool (1.5.1.84.g9f2e646-1) unstable; urgency=low

  * Drop BSD dependencies in Debian/kFreeBSD (try to fix FTBFS with Debian/BSD).

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 09 Sep 2013 15:52:39 +0400

tarantool (1.5.1.82.ga064ebe-1) unstable; urgency=low

  * Remove tarantool/config.h pointedly (try to fix FTBFS with Debian/kFreeBSD).

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 09 Sep 2013 13:35:06 +0400

tarantool (1.5.1.81.g4382f16-1) unstable; urgency=low

  * Fix debian/rules clean section (cleanup CMake files).

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 08 Sep 2013 23:05:29 +0400

tarantool (1.5.1.80.gc84e35c-1) unstable; urgency=low

  * New snapshot (try to fix FTBFS with Debian/kFreeBSD).

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 08 Sep 2013 22:14:09 +0400

tarantool (1.5.1.78.g2e82d26-1) unstable; urgency=low

  * New snapshot. Integration upload.
   - Add missing copyright holders, closes: #722059
   - Drop non-free materials from tarbal, closes: #722060
   - Fix memory leak in box.ipc.channel:put.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 08 Sep 2013 02:00:51 +0400

tarantool (1.5.1.76.g5ed3fbe-1) unstable; urgency=low

  * New snapshot.
   - Fix memory leak in box.ipc.channel:put(v, 0)

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 05 Sep 2013 14:36:52 +0400

tarantool (1.5.1.73.gd1b3db6-1) unstable; urgency=low

  * New snapshot
   - Fix crashes with broken snapshot.
   - Cleanup debian/copyright (drop php-connector section).
   - Drop empty TODO files from binary packages.
   - debian/* relicensed as tarantool.
   - tarantool-plugins has 'any' architecture: it depends on plugins
     that contain ELF-files.
   - Fix FTBFS with Debian/kFreeBSD, closes: #715358.
   - Drop irrelevant debian/README.source.
   - Add postgresql-plugin package.
   - Add mysql-plugin package.
   - Add -plugins package (Now it depends on other plugin. Then it will
     contain some internal tarantool plugins).
   - Remove non-free rfc4627.txt.
   - Update debian/copyright.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 04 Sep 2013 12:45:34 +0400

tarantool (1.4.9+20130611.2012-1) unstable; urgency=low

  * New snapshot, fix crash with gcc-4.7.3.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 11 Jun 2013 20:12:22 +0400

tarantool (1.4.9+20130608.2059-1) unstable; urgency=low

  * New upstream release: move to C++ from ObjectC. Add box.cjson module.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sat, 08 Jun 2013 20:59:30 +0400

tarantool (1.4.9+20130415.1808-1) unstable; urgency=low

  * New upstream release (fix disconnect bug).
    https://bugs.launchpad.net/tarantool/+bug/1168076

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 15 Apr 2013 18:08:14 +0400

tarantool (1.4.9-1) unstable; urgency=low

  * New upstream release.
   + Apply patch from Colin Watson <cjwatson@ubuntu.com>, closes: #703044,
   + Fix VCS-link, closes: #681703
   + Fix FTBFS (kfreebsd), patch from Steven Chamberlain <steven@pyro.eu.org>,
     closes: 695541

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 10 Apr 2013 12:08:49 +0400

tarantool (1.4.8+20130306.1415-1) unstable; urgency=low

  * New snapshot (some fixes in iproto).

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 06 Mar 2013 14:15:10 +0400

tarantool (1.4.8+20130212.1728-1) unstable; urgency=low

  * Rebuilt last snapshot for Debian.

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 12 Feb 2013 17:27:48 +0400

tarantool (1.4.8+20130212.1647-1) nowtaxi; urgency=low

  * New snapshot (fix async I/O bugs).

 -- Roman V. Nikolaev <rshadow@rambler.ru>  Tue, 12 Feb 2013 16:47:10 +0400

tarantool (1.4.8+20130122.1705-1) unstable; urgency=low

  * New snapshot (fix spam in tarantool.log).



=== debian/control ===
Source: tarantool-lts
Priority: optional
Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Build-Depends: cdbs, debhelper (>= 8),
 cmake,
 libreadline-dev,
 libncurses5-dev,
 libiberty-dev | binutils-dev,
 libmysqlclient-dev,
 libpq-dev
Section: database
Standards-Version: 3.9.6
Homepage: http://tarantool.org/
VCS-Browser: https://github.com/tarantool/tarantool
VCS-Git: git://github.com/tarantool/tarantool.git

Package: tarantool-lts-common
Architecture: all
Priority: optional
Conflicts: tarantool-common (<< 1.5.3)
Replaces: tarantool-common (<< 1.5.3)
Depends: ${misc:Depends}, adduser, lsb-base
Description: Tarantool in-memory database - common files
 Tarantool is an in-memory database and Lua application server.
 This package provides scripts to work with tarantool configuration
 and log files.

Package: tarantool-lts
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, tarantool-lts-common
Conflicts: tarantool-dbg (<< 1.5.2),
 tarantool (<< 1.6),
 tarantool-client (<< 1.5.0)
Replaces: tarantool (<< 1.6)
Suggests: tarantool-lts-client (>= 1.5.0), libdr-tarantool-perl
Description: In-memory database with Lua application server
 Tarantool is an in-memory database and Lua application server.
 Its key properties include:
 .
  * flexible data model
  * multiple index types: HASH, TREE, BITSET
  * optional persistence and strong data durability
  * log streaming replication
  * Lua functions, procedures, triggers, with rich access to database API,
    JSON support, inter-procedure and network communication libraries
  * a command line client supporting simple SQL and a native Lua console
 .
 This package provides Tarantool server.

Package: tarantool-lts-dev
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Section: libdevel
Conflicts: libtarantool-dev (<< 1.6)
Replaces: libtarantool-dev (<< 1.6)
Depends: ${shlibs:Depends}, ${misc:Depends},
 tarantool-lts (= ${binary:Version}),
Description: Tarantool in-memory database - development headers
 Tarantool is an in-memory database and Lua application server.
 This package provides server headers needed to build pluggable modules.

Package: tarantool-lts-modules
Conflicts: tarantool-plugins (<< 1.5.3)
Replaces: tarantool-plugins (<< 1.5.3)
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends},
 tarantool-lts (= ${binary:Version})
Recommends:
 tarantool-postgresql-module (= ${binary:Version}),
 tarantool-mysql-module (= ${binary:Version}),
 tarantool-sophia-module (= ${binary:Version})
Description: Tarantool in-memory database - all plug-ins bundle
 Tarantool is an in-memory database and Lua application server.
 This package provides some Tarantool additional modules.

Package: tarantool-lts-postgresql-module
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Conflicts: tarantool-postgresql-plugin (<< 1.5.3)
Replaces: tarantool-postgresql-plugin (<< 1.6)
Depends: ${shlibs:Depends}, ${misc:Depends},
 tarantool-lts-modules (= ${binary:Version})
Description: Tarantool in-memory database - PostgreSQL connector
 Tarantool is an in-memory database and Lua application server.
 This package contains a connector to PostgreSQL database for
 Tarantool Lua stored procedures.

Package: tarantool-lts-mysql-module
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Conflicts: tarantool-mysql-plugin (<< 1.5.3)
Replaces: tarantool-mysql-plugin (<< 1.6)
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends},
 tarantool-lts-modules (= ${binary:Version})
Description: Tarantool in-memory database - MySQL connector
 Tarantool is an in-memory database and Lua application server.
 This package contains a connector to MySQL database for Tarantool
 Lua stored procedures.

Package: tarantool-lts-sophia-module
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends},
 tarantool-lts (= ${binary:Version}),
 tarantool-lts-modules (= ${binary:Version})
Description: Tarantool in-memory database - sophia bindings
 Tarantool is an in-memory database and Lua application server.
 This package contains a bindings to the Sophia database for
 Tarantool Lua stored procedures.

Package: tarantool-lts-client
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: tarantool-lts, tarantool-tls-client-dbg
Conflicts: tarantool-client (<< 1.6)
Replaces: tarantool-client (<< 1.6)
Description: Tarantool in-memory database - command line client
 Tarantool is an in-memory database and Lua application server.
 This package provides a command line client for Tarantool
 server with support of readline, command history, reader of 
 server binary logs and snapshot files.

## tarantool-lts 1.5.5-18

=== CMakeLists.txt ===
--- 
+++ 
@@ -78,6 +78,7 @@
 check_function_exists(memrchr HAVE_MEMRCHR)
 
 check_function_exists(funopen HAVE_FUNOPEN)
+check_function_exists(fopencookie HAVE_FOPENCOOKIE)
 
 #
 # Some versions of GNU libc define non-portable __libc_stack_end
@@ -96,7 +97,7 @@
 #
 set (CPACK_PACKAGE_VERSION_MAJOR "1")
 set (CPACK_PACKAGE_VERSION_MINOR "5")
-set (CPACK_PACKAGE_VERSION_PATCH "4")
+set (CPACK_PACKAGE_VERSION_PATCH "5")
 
 set (PACKAGE_VERSION "")
 
@@ -386,4 +387,3 @@
 message (STATUS "ENABLE_BUNDLED_LUAJIT: ${ENABLE_BUNDLED_LUAJIT}")
 message (STATUS "ENABLE_BUNDLED_LIBEV: ${ENABLE_BUNDLED_LIBEV}")
 message (STATUS "ENABLE_BUNDLED_LIBEIO: ${ENABLE_BUNDLED_LIBEIO}")
-message (STATUS "ENABLE_BUNDLED_LIBCORO: ${ENABLE_BUNDLED_LIBCORO}")

=== doc/CMakeLists.txt ===
configure_file(
    "${PROJECT_SOURCE_DIR}/doc/tnt.ent.cmake"
    "${PROJECT_BINARY_DIR}/doc/tnt.ent"
    )

configure_file(
    "${PROJECT_SOURCE_DIR}/doc/www-data.in/download.cmake"
    "${PROJECT_BINARY_DIR}/doc/www-data.in/_text/download.md"
    )

add_subdirectory(man)

if (ENABLE_DOC)
    add_subdirectory(user)
    add_subdirectory(developer)
    add_subdirectory(www-data.in)
endif()

=== extra/CMakeLists.txt ===
#
# Scripts for a RPM package
#
if (ENABLE_RPM)
    # chmod +x 655
    install (FILES tarantool_box DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}/init.d/
         PERMISSIONS
         OWNER_READ OWNER_WRITE
         GROUP_READ GROUP_EXECUTE
         WORLD_READ WORLD_EXECUTE)
    # chmod +x 755
    install (FILES tarantool_multi.sh DESTINATION bin
         PERMISSIONS
         OWNER_READ OWNER_WRITE OWNER_EXECUTE
         GROUP_READ GROUP_EXECUTE
         WORLD_READ WORLD_EXECUTE)
    # chmod +x 755
    install (FILES tarantool_deploy.sh DESTINATION bin
         PERMISSIONS
         OWNER_READ OWNER_WRITE OWNER_EXECUTE
         GROUP_READ GROUP_EXECUTE
         WORLD_READ WORLD_EXECUTE)
endif()

configure_file(rpm/tarantool.rpm.spec.in rpm/tarantool.rpm.spec @ONLY)

if (TARGET_OS_DARWIN)
    # NOTE: need add execution 'plutil -lint org.tarantool.tarantool_${TARANTOOL_PRODUCT}.plist
    # to check syntax of plist file.
    # Also cmake doesn't support changing package id from 'com.' to 'org.'
    # Need chage to 'org.' after update lines this file:
    # https://github.com/Kitware/CMake/blob/v2.8.11.2/Source/CPack/cmCPackPackageMakerGenerator.cxx#L763
    #
    # ^^^ DO NOT CHANGE DARWIN_PACKAGE_ID BEFORE SEE URL ABOVE ^^^
    #
    set (DARWIN_PACKAGE_ID "com")
    set (LUANCHD_PLIST "${DARWIN_PACKAGE_ID}.${CPACK_PACKAGE_VENDOR}.tarantool_${TARANTOOL_PRODUCT}.plist")
    # Configure scripts for *.pkg and luanchd daemon by templates
    configure_file(dmg/postflight.in postflight @ONLY)
    configure_file(org.tarantool.in ${LUANCHD_PLIST} @ONLY)
    # chmod +x 644
    install (FILES ${CMAKE_BINARY_DIR}/extra/${LUANCHD_PLIST}
                 DESTINATION share/tarantool
         PERMISSIONS
         OWNER_READ OWNER_WRITE
         GROUP_READ GROUP_READ
         WORLD_READ WORLD_READ)
endif()

add_executable(txt2c txt2c.c)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -66,6 +66,7 @@
 lua_source(lua_sources lua/session.lua)
 lua_source(lua_sources lua/bsdsocket.lua)
 lua_source(lua_sources lua/errno.lua)
+lua_source(lua_sources lua/log.lua)
 
 add_custom_target(generate_lua_sources
     WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/box

=== test/CMakeLists.txt ===
enable_tnt_compile_flags()

add_compile_flags("C;CXX"
    "-Wno-unused-parameter")

add_custom_target(test
    COMMAND ${PROJECT_SOURCE_DIR}/test/test-run.py --builddir=${PROJECT_BINARY_DIR} --vardir=${PROJECT_BINARY_DIR}/test/var)

add_custom_target(test-force
    COMMAND ${PROJECT_SOURCE_DIR}/test/test-run.py --builddir=${PROJECT_BINARY_DIR} --force --vardir=${PROJECT_BINARY_DIR}/test/var)


add_subdirectory(unit)
add_subdirectory(box)
add_subdirectory(connector_c)

macro(install_cfg type_cfg dest)
    install (FILES ${CMAKE_SOURCE_DIR}/test/share/tarantool_${type_cfg}.cfg
             DESTINATION ${dest}
             RENAME "tarantool.cfg")
endmacro(install_cfg)

if (ENABLE_RPM)
    install_cfg(rpm ${CMAKE_INSTALL_SYSCONFDIR}/tarantool/)
    install (FILES ${CMAKE_SOURCE_DIR}/test/box/00000000000000000001.snap
             DESTINATION ${CMAKE_INSTALL_DATADIR}/tarantool/)
elseif(NOT ENABLE_RPM_SCL)
    if (TARGET_OS_DARWIN)
        install_cfg(dmg ${CMAKE_INSTALL_SYSCONFDIR})
    else()
        install_cfg(tgz ${CMAKE_INSTALL_SYSCONFDIR})
    endif()

    install (FILES ${CMAKE_SOURCE_DIR}/test/box/00000000000000000001.snap
             DESTINATION "${CMAKE_INSTALL_SHAREDSTATEDIR}/tarantool")
endif()

=== client/tarantar/CMakeLists.txt ===
project(tnt_snap)

set (util_snap "tarantar")
set (util_snap_sources sha1.c main.c config.c space.c options.c indexate.c ref.c cursor.c snapshot.c update.cc compat.c)
set (util_snap_libs tntrpl tntnet tnt)

list(APPEND util_snap_sources
    ${CMAKE_SOURCE_DIR}/third_party/crc32.c
    ${CMAKE_SOURCE_DIR}/cfg/tarantool_box_cfg.c
    ${CMAKE_SOURCE_DIR}/cfg/prscfg.c
    ${CMAKE_SOURCE_DIR}/src/errcode.c
    ${CMAKE_SOURCE_DIR}/src/exception.cc
    ${CMAKE_SOURCE_DIR}/src/rope.c
    ${CMAKE_SOURCE_DIR}/src/box/tuple_update.cc )

set_source_files_properties(${CMAKE_SOURCE_DIR}/cfg/tarantool_box_cfg.c
     ${CMAKE_SOURCE_DIR}/cfg/prscfg.c PROPERTIES COMPILE_FLAGS
     "-Wno-unused-parameter"
     GENERATED True)

set_source_files_properties(${util_snap_sources} PROPERTIES OBJECT_DEPENDS
    ${CMAKE_SOURCE_DIR}/cfg/tarantool_box_cfg.h)

set_source_files_compile_flags(${util_snap_sources})
add_executable(${util_snap} ${util_snap_sources})

target_link_libraries (${util_snap} ${util_snap_libs} gopt small)

install (TARGETS ${util_snap} DESTINATION bin)

=== client/tarantool/CMakeLists.txt ===
project(tnt_cli)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/" ${CMAKE_MODULE_PATH})

include(FindReadline)

if (NOT READLINE_FOUND)
    message(FATAL_ERROR "readline library not found.")
endif()

set (cli "tarantool")
set (cli_sources tc.c tc_opt.c tc_admin.c tc_query.c tc_print.c tc_buf.c
		tc_cli.c tc_store.c tc_print_xlog.c tc_print_snap.c tc_pager.c)
set (cli_libs tntrpl tntnet tntsql tnt gopt ${READLINE_LIBRARIES})

include_directories(${READLINE_INCLUDE_DIR})
list(APPEND cli_sources ${CMAKE_SOURCE_DIR}/src/errcode.c)
add_executable(${cli} ${cli_sources})
set_source_files_compile_flags("TARANTOOL" ${cli_sources})
target_link_libraries (${cli} ${cli_libs})

install (TARGETS ${cli} DESTINATION bin)

=== connector/c/CMakeLists.txt ===

#
# library soname version
#
set(LIBTNT_VERSION_MAJOR "1")
set(LIBTNT_VERSION_MINOR "1")

set(LIBTNT_VERSION   "${LIBTNT_VERSION_MAJOR}.${LIBTNT_VERSION_MINOR}")
set(LIBTNT_SOVERSION "${LIBTNT_VERSION_MAJOR}")

include_directories("${PROJECT_SOURCE_DIR}/connector/c/include")

add_subdirectory(tnt)
add_subdirectory(tntsql)
add_subdirectory(tntnet)
add_subdirectory(tntrpl)
add_subdirectory(include)

=== src/lib/CMakeLists.txt ===
add_subdirectory(bit)
add_subdirectory(bitset)
add_subdirectory(small)
add_subdirectory(salad)

=== src/module/CMakeLists.txt ===
add_subdirectory(sql)
add_subdirectory(pg)
add_subdirectory(mysql)
add_subdirectory(sophia)

=== test/unit/CMakeLists.txt ===
--- 
+++ 
@@ -30,3 +30,5 @@
 add_executable(avl_tree.test avl_tree.c)
 target_link_libraries(avl_tree.test m)
 target_link_libraries(avl_tree.test misc)
+add_executable(guava.test guava.c)
+target_link_libraries(guava.test salad)

=== third_party/lua-cjson/Makefile ===
##### Available defines for CJSON_CFLAGS #####
##
## USE_INTERNAL_ISINF:      Workaround for Solaris platforms missing isinf().
## DISABLE_INVALID_NUMBERS: Permanently disable invalid JSON numbers:
##                          NaN, Infinity, hex.
##
## Optional built-in number conversion uses the following defines:
## USE_INTERNAL_FPCONV:     Use builtin strtod/dtoa for numeric conversions.
## IEEE_BIG_ENDIAN:         Required on big endian architectures.
## MULTIPLE_THREADS:        Must be set when Lua CJSON may be used in a
##                          multi-threaded application. Requries _pthreads_.

##### Build defaults #####
LUA_VERSION =       5.1
TARGET =            cjson.so
PREFIX =            /usr/local
#CFLAGS =            -g -Wall -pedantic -fno-inline
CFLAGS =            -O3 -Wall -pedantic -DNDEBUG
CJSON_CFLAGS =      -fpic
CJSON_LDFLAGS =     -shared
LUA_INCLUDE_DIR =   $(PREFIX)/include
LUA_CMODULE_DIR =   $(PREFIX)/lib/lua/$(LUA_VERSION)
LUA_MODULE_DIR =    $(PREFIX)/share/lua/$(LUA_VERSION)
LUA_BIN_DIR =       $(PREFIX)/bin

##### Platform overrides #####
##
## Tweak one of the platform sections below to suit your situation.
##
## See http://lua-users.org/wiki/BuildingModules for further platform
## specific details.

## Linux

## FreeBSD
#LUA_INCLUDE_DIR =   $(PREFIX)/include/lua51

## MacOSX (Macports)
#PREFIX =            /opt/local
#CJSON_LDFLAGS =     -bundle -undefined dynamic_lookup

## Solaris
#CC           =      gcc
#CJSON_CFLAGS =      -fpic -DUSE_INTERNAL_ISINF

## Windows (MinGW)
#TARGET =            cjson.dll
#PREFIX =            /home/user/opt
#CJSON_CFLAGS =      -DDISABLE_INVALID_NUMBERS
#CJSON_LDFLAGS =     -shared -L$(PREFIX)/lib -llua51
#LUA_BIN_SUFFIX =    .lua

##### Number conversion configuration #####

## Use Libc support for number conversion (default)
FPCONV_OBJS =       fpconv.o

## Use built in number conversion
#FPCONV_OBJS =       g_fmt.o dtoa.o
#CJSON_CFLAGS +=     -DUSE_INTERNAL_FPCONV

## Compile built in number conversion for big endian architectures
#CJSON_CFLAGS +=     -DIEEE_BIG_ENDIAN

## Compile built in number conversion to support multi-threaded
## applications (recommended)
#CJSON_CFLAGS +=     -pthread -DMULTIPLE_THREADS
#CJSON_LDFLAGS +=    -pthread

##### End customisable sections #####

TEST_FILES =        README bench.lua genutf8.pl test.lua octets-escaped.dat \
                    example1.json example2.json example3.json example4.json \
                    example5.json numbers.json rfc-example1.json \
                    rfc-example2.json types.json
DATAPERM =          644
EXECPERM =          755

ASCIIDOC =          asciidoc

BUILD_CFLAGS =      -I$(LUA_INCLUDE_DIR) $(CJSON_CFLAGS)
OBJS =              lua_cjson.o strbuf.o $(FPCONV_OBJS)

.PHONY: all clean install install-extra doc

.SUFFIXES: .html .txt

.c.o:
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $(BUILD_CFLAGS) -o $@ $<

.txt.html:
	$(ASCIIDOC) -n -a toc $<

all: $(TARGET)

doc: manual.html performance.html

$(TARGET): $(OBJS)
	$(CC) $(LDFLAGS) $(CJSON_LDFLAGS) -o $@ $(OBJS)

install: $(TARGET)
	mkdir -p $(DESTDIR)/$(LUA_CMODULE_DIR)
	cp $(TARGET) $(DESTDIR)/$(LUA_CMODULE_DIR)
	chmod $(EXECPERM) $(DESTDIR)/$(LUA_CMODULE_DIR)/$(TARGET)

install-extra:
	mkdir -p $(DESTDIR)/$(LUA_MODULE_DIR)/cjson/tests \
		$(DESTDIR)/$(LUA_BIN_DIR)
	cp lua/cjson/util.lua $(DESTDIR)/$(LUA_MODULE_DIR)/cjson
	chmod $(DATAPERM) $(DESTDIR)/$(LUA_MODULE_DIR)/cjson/util.lua
	cp lua/lua2json.lua $(DESTDIR)/$(LUA_BIN_DIR)/lua2json$(LUA_BIN_SUFFIX)
	chmod $(EXECPERM) $(DESTDIR)/$(LUA_BIN_DIR)/lua2json$(LUA_BIN_SUFFIX)
	cp lua/json2lua.lua $(DESTDIR)/$(LUA_BIN_DIR)/json2lua$(LUA_BIN_SUFFIX)
	chmod $(EXECPERM) $(DESTDIR)/$(LUA_BIN_DIR)/json2lua$(LUA_BIN_SUFFIX)
	cd tests; cp $(TEST_FILES) $(DESTDIR)/$(LUA_MODULE_DIR)/cjson/tests
	cd tests; chmod $(DATAPERM) $(TEST_FILES); chmod $(EXECPERM) *.lua *.pl

clean:
	rm -f *.o $(TARGET)

## tarantool-lts 1.5.5-18-g2998d20

=== debian/changelog ===
tarantool-lts (1.5.5-18-g2998d20-1ubuntu1) xenial; urgency=medium

  * Patch to build with mysqlclient, not mysqlclient_r (LP: #1570380)

 -- Lars Tangvald <lars.tangvald@oracle.com>  Thu, 14 Apr 2016 15:15:19 +0200

tarantool-lts (1.5.5-18-g2998d20-1build1) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 13:03:18 +0000

tarantool-lts (1.5.5-18-g2998d20-1) unstable; urgency=medium

  * Add conflict with tarantool, closes: #793867.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sat, 12 Sep 2015 12:13:42 +0300

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: tarantool-lts
 Priority: optional
-Maintainer: Dmitry E. Oboukhov <unera@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Dmitry E. Oboukhov <unera@debian.org>
 Build-Depends: cdbs, debhelper (>= 8),
  cmake,
  libreadline-dev,
@@ -115,7 +116,7 @@
 Priority: optional
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: tarantool-lts, tarantool-tls-client-dbg
-Conflicts: tarantool-client (<< 1.6)
+Conflicts: tarantool-client (<< 1.6), tarantool
 Replaces: tarantool-client (<< 1.6)
 Description: Tarantool in-memory database - command line client
  Tarantool is an in-memory database and Lua application server.
